## ghc 8.0.2

=== Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

# Eliminate use of the built-in implicit rules, and clear out the default list
# of suffixes for suffix rules. Speeds up make quite a bit. Both are needed
# for the shortest `make -d` output.
# Don't set --no-builtin-variables; some rules might stop working if you do
# (e.g. 'make clean' in testsuite/ currently relies on an implicit $RM).
MAKEFLAGS += --no-builtin-rules
.SUFFIXES:


# -----------------------------------------------------------------------------
# Sanitize environment

# See Trac #11530
export GREP_OPTIONS :=

ifneq "$(filter maintainer-clean distclean clean clean_% help,$(MAKECMDGOALS))" ""
-include mk/config.mk
else
include mk/config.mk
ifeq "$(ProjectVersion)" ""
$(error Please run ./configure first)
endif
endif

include mk/custom-settings.mk


ifeq "$(wildcard distrib/)" ""

# We're in a bindist

.PHONY: default
default:
	@echo 'Run "make install" to install'
	@false

.PHONY: install show
install show:
	$(MAKE) --no-print-directory -f ghc.mk $@ BINDIST=YES NO_INCLUDE_DEPS=YES

# Note [install-strip]
#
# install-strip is like install, but it strips the executable files while
# installing them.
#
# From http://www.gnu.org/prep/standards/html_node/Standard-Targets.html:
#
#   "install-strip should not strip the executables in the build directory
#   which are being copied for installation. It should only strip the copies
#   that are installed. "

.PHONY: install-strip
install-strip:
	# See Note [install-strip].
	$(MAKE) --no-print-directory -f ghc.mk INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' install BINDIST=YES NO_INCLUDE_DEPS=YES

else

.PHONY: default
default : all
	@:

# For help, type 'make help'
.PHONY: help
help:
	@cat MAKEHELP.md

# Verify that stage 0 LLVM backend isn't affected by Bug #9439 if needed
ifeq "$(GHC_LLVM_AFFECTED_BY_9439)" "1"
ifneq "$(findstring -fllvm,$(SRC_HC_OPTS) $(GhcHcOpts) $(GhcStage1HcOpts))" ""
$(error Stage 0 compiler is affected by Bug #9439. Refusing to bootstrap with -fllvm)
endif
endif

# No need to update makefiles for these targets:
# (the ones we're filtering out)
REALGOALS=$(filter-out \
    binary-dist \
    binary-dist-prep \
    install-strip \
    sdist sdist-ghc \
    sdist-ghc-prep \
    sdist-windows-tarballs \
    sdist-windows-tarballs-prep \
    sdist-testsuite \
    sdist-testsuite-prep \
    bootstrapping-files \
    framework-pkg \
    clean \
    clean_% \
    distclean \
    maintainer-clean \
    show \
    show! \
    echo \
    help \
    test \
    fulltest \
    slowtest \
    fasttest \
  ,$(MAKECMDGOALS))

# configure touches certain files even if they haven't changed.  This
# can mean a lot of unnecessary recompilation after a re-configure, so
# here we cache the old versions of these files so we can restore the
# timestamps.
%.old:  %
	@set -x && test -f $@ && cmp -s $< $@ || cp -p $< $@
	touch -r $@ $<


# NB. not the same as saying '%: ...', which doesn't do the right thing:
# it does nothing if we specify a target that already exists.
.PHONY: $(REALGOALS) all
$(REALGOALS) all: mk/config.mk.old mk/project.mk.old compiler/ghc.cabal.old
ifneq "$(OMIT_PHASE_0)" "YES"
	@echo "===--- building phase 0"
	$(MAKE) --no-print-directory -f ghc.mk phase=0 phase_0_builds
endif
ifneq "$(OMIT_PHASE_1)" "YES"
	@echo "===--- building phase 1"
	$(MAKE) --no-print-directory -f ghc.mk phase=1 phase_1_builds
endif
	@echo "===--- building final phase"
	$(MAKE) --no-print-directory -f ghc.mk phase=final $@

.PHONY: binary-dist
binary-dist: binary-dist-prep
	mv bindistprep/*.tar.$(TAR_COMP_EXT) .

.PHONY: binary-dist-prep
binary-dist-prep:
ifeq "$(mingw32_TARGET_OS)" "1"
	$(MAKE) --no-print-directory -f ghc.mk windows-binary-dist-prep
else
	rm -f bindist-list
	$(MAKE) --no-print-directory -f ghc.mk bindist-list BINDIST=YES
	$(MAKE) --no-print-directory -f ghc.mk unix-binary-dist-prep
endif

.PHONY: install-strip
install-strip:
	# See Note [install-strip].
	$(MAKE) --no-print-directory -f ghc.mk INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' install

.PHONY: sdist sdist-ghc sdist-ghc-prep sdist-windows-tarballs sdist-windows-tarballs-prep sdist-testsuite sdist-testsuite-prep
# Just running `./boot && ./configure && make sdist` should work, so skip
# phase 0 and 1 and don't build any dependency files.
sdist sdist-ghc sdist-ghc-prep sdist-windows-tarballs sdist-windows-tarballs-prep sdist-testsuite sdist-testsuite-prep :
	$(MAKE) --no-print-directory -f ghc.mk $@ NO_INCLUDE_DEPS=YES NO_INCLUDE_PKGDATA=YES

.PHONY: clean distclean maintainer-clean
clean distclean maintainer-clean:
	$(MAKE) --no-print-directory -f ghc.mk $@ CLEANING=YES
	test ! -d testsuite || $(MAKE) -C testsuite $@

.PHONY: $(filter clean_%,$(MAKECMDGOALS))
$(filter clean_%, $(MAKECMDGOALS)) : clean_% :
	$(MAKE) --no-print-directory -f ghc.mk $@ CLEANING=YES

.PHONY: bootstrapping-files show echo
bootstrapping-files show echo:
	$(MAKE) --no-print-directory -f ghc.mk $@

.PHONY: show!
show!:
	$(MAKE) --no-print-directory -f ghc.mk show NO_INCLUDE_PKGDATA=YES

ifeq "$(darwin_TARGET_OS)" "1"
.PHONY: framework-pkg
framework-pkg:
	$(MAKE) -C distrib/MacOS $@
endif

# If the user says 'make A B', then we don't want to invoke two
# instances of the rule above in parallel:
.NOTPARALLEL:

endif

# Note [validate and testsuite speed]
#
# There are 3 different validate and testsuite speed settings:
# fast, normal and slow.
#
#                              how    how   used
#           cd tests  config.  many   many  by
# validate  && make   speed=   tests  ways  whom
# =============================================================================
# --fast    fast      2        some   1+exs Travis (to stay within time limit)
# --normal  test      1        all    1+exs Phabricator (slow takes too long?)
# --slow    slow      0        all    all   Nightly (slow is ok)
#
#           accept    1        all    1
#
# `--fast` and `--normal` run one default way, as well as any other ways which
# are explicitly requested by the test using extra_ways().
#
# `make accept` should run all tests exactly once. There is no point in
# accepting a test for multiple ways, since it should produce the same output
# for all ways.
#
# To make sure all .stderr and .stdout files in the testsuite are never
# out-of-date, it is useful if Phabricator, via a normal `./validate` and `make
# test`, runs each test at least once.
.PHONY: fasttest
fasttest:
	$(MAKE) -C testsuite/tests CLEANUP=1 SUMMARY_FILE=../../testsuite_summary.txt fast

.PHONY: test
test:
	$(MAKE) -C testsuite/tests CLEANUP=1 SUMMARY_FILE=../../testsuite_summary.txt

.PHONY: slowtest fulltest
slowtest fulltest:
	$(MAKE) -C testsuite/tests CLEANUP=1 SUMMARY_FILE=../../testsuite_summary.txt slow

=== bindisttest/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

.PHONY: default_target

default_target: all

# Ideally we'd just include something to give us variables
# for paths and arguments to tools etc, and those set in mk/build.mk.
TOP=..
include $(TOP)/mk/tree.mk
include $(TOP)/mk/config.mk

ifeq "$(TEST_PREP)" "YES"
BIN_DIST_TEST_TAR_COMP = ../$(BIN_DIST_PREP_TAR_COMP)
else
BIN_DIST_TEST_TAR_COMP = ../$(BIN_DIST_TAR_COMP)
endif

all:
	"$(RM)" $(RM_OPTS_REC) $(BIN_DIST_INST_SUBDIR)
	"$(RM)" $(RM_OPTS_REC) a/b/c/*
	"$(RM)" $(RM_OPTS) HelloWorld HelloWorld.o HelloWorld.hi output
# We use the a/b/c subdirectory as configure looks for install-sh in
# . .. ../.. and we don't want it to find the build system's install-sh.
#
# NB. tar has funny interpretation of filenames sometimes (thinking
# c:/foo is a remote file), so it's safer to bzip and then pipe into
# tar rather than using tar -xjf:
	cd a/b/c/ && $(TAR_COMP_CMD) -cd ../../../$(BIN_DIST_TEST_TAR_COMP) | $(TAR_CMD) -xf -
ifeq "$(Windows)" "YES"
	mv a/b/c/$(BIN_DIST_NAME) $(BIN_DIST_INST_DIR)
else
	cd a/b/c/$(BIN_DIST_NAME) && ./configure --prefix=$(BIN_DIST_INST_DIR)
	cd a/b/c/$(BIN_DIST_NAME) && $(MAKE) install
endif
	$(BIN_DIST_INST_DIR)/bin/runghc HelloWorld > output
	$(CONTEXT_DIFF) output expected_output
	$(BIN_DIST_INST_DIR)/bin/ghc --make HelloWorld
	./HelloWorld > output
	$(CONTEXT_DIFF) output expected_output
# Without --no-user-package-db we might pick up random packages from ~/.ghc
	$(BIN_DIST_INST_DIR)/bin/ghc-pkg check --no-user-package-db

clean distclean:
	"$(RM)" $(RM_OPTS_REC) $(BIN_DIST_INST_SUBDIR)
	"$(RM)" $(RM_OPTS_REC) a/b/c/*
	"$(RM)" $(RM_OPTS) HelloWorld HelloWorld.o HelloWorld.hi output

# Ignore a load of other standard targets
install install-docs doc:
	@:

show:
	@echo '$(VALUE)="$($(VALUE))"'

=== compiler/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

# If the user says 'make' or 'make stage=2' here, we behave as if they were
# in the ghc directory instead, so that the executable GHC gets built.
.PHONY: default_to_ghc all_ghc
default_to_ghc : all_ghc

dir = compiler

include ../mk/compiler-ghc.mk

all_ghc :
	+$(TOPMAKE) all_ghc $(EXTRA_MAKE_OPTS)

=== docs/Makefile ===
dir = docs
TOP = ..
include $(TOP)/mk/sub-makefile.mk

=== driver/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = driver
TOP = ..
include $(TOP)/mk/sub-makefile.mk

=== rts/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = rts
TOP = ..
include $(TOP)/mk/sub-makefile.mk

FAST_MAKE_OPTS += stage=none

=== docs/backpack/Makefile ===
all: backpack-impl.pdf backpack-manual.pdf algorithm.pdf

backpack-impl.pdf: backpack-impl.tex
	latexmk -pdf -latexoption=-halt-on-error -latexoption=-file-line-error -latexoption=-synctex=1 backpack-impl.tex || ! rm -f $@

backpack-manual.pdf: backpack-manual.tex
	latexmk -pdf -latexoption=-halt-on-error -latexoption=-file-line-error -latexoption=-synctex=1 backpack-manual.tex || ! rm -f $@

algorithm.pdf: algorithm.tex
	latexmk -pdf -latexoption=-halt-on-error -latexoption=-file-line-error -latexoption=-synctex=1 algorithm.tex || ! rm -f $@

=== docs/users_guide/Makefile ===
dir = docs/users_guide
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== libraries/doc/Makefile ===
TOP=..
include $(TOP)/mk/boilerplate.mk
XML_DOC=libraries
include $(TOP)/mk/target.mk

=== utils/checkUniques/Makefile ===
TOP = ../..

GHC = ghc

.PHONY: check

check:
	./check-uniques.py $(TOP)

=== utils/genapply/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/genapply
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== utils/genprimopcode/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/genprimopcode
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== debian/changelog ===
ghc (8.0.2-11) unstable; urgency=medium

  [ Ilias Tsitsimpis ]
  * Change Priority to optional. Since Debian Policy version 4.0.1,
    priority extra has been deprecated.
  * Use the HTTPS form of the copyright-format URL
  * Modify d/watch and Source field in d/copyright to use HTTPS
  * Declare compliance with Debian policy 4.1.1

  [ Sean Whitton ]
  * Add fix-hssplicety.patch (Closes: #867195).

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 06 Feb 2018 14:01:18 -0700

ghc (8.0.2-10) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Make ghc cross-buildable

  [ Gianfranco Costamagna ]
  * Drop arm64 switch to gold, now gcc/binutils should be fixed.
  * Team upload.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 29 Aug 2017 23:10:26 +0200

ghc (8.0.2-9) unstable; urgency=medium

  * Team upload.
  * Patch arm64 before autoreconf.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 26 Aug 2017 19:04:27 +0200

ghc (8.0.2-8) unstable; urgency=high

  * Team upload
  * Try arm64 with my Ubuntu patch.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 26 Aug 2017 10:54:27 +0200

ghc (8.0.2-7) unstable; urgency=medium

  * Only apply arm64 linker patch on arm64, to avoid conflict with
    armel-only patch.

 -- Clint Adams <clint@debian.org>  Fri, 25 Aug 2017 11:19:17 -0400

ghc (8.0.2-6) unstable; urgency=medium

  * Switch arm64 linker to bfd, since gold is garbage.

 -- Clint Adams <clint@debian.org>  Fri, 25 Aug 2017 08:36:53 -0400

ghc (8.0.2-5) unstable; urgency=medium

  * Patch from James Clarke to fix powerpc breakage caused by
    powerpcspe patch.

 -- Clint Adams <clint@debian.org>  Tue, 27 Jun 2017 07:50:03 -0400

ghc (8.0.2-4) unstable; urgency=medium

  * Revert cross-compilation patch.

 -- Clint Adams <clint@debian.org>  Sun, 25 Jun 2017 12:38:02 -0400

ghc (8.0.2-3) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Build with --enable-unregisterised on powerpcspe.  closes: #861806.
  * Support building ghc without building haddock, for cross-compilation.
    closes: #853285, #853773.

  [ Helmut Grohne ]
  * Do not run tests under DEB_BUILD_OPTIONS=nocheck (Closes: #853743).

  [ Clint Adams ]
  * Conflict with libghc-cabal-dev (<< 1.24.2.1) to avoid wanna-build
    confusion.

 -- Clint Adams <clint@debian.org>  Sun, 25 Jun 2017 10:21:43 -0400

ghc (8.0.2-1) unstable; urgency=medium

  * Team upload
  * New upstream release, remove patches addressed upstream
    -add-missing-MO_WriteBarrier
    -no-pie
    -find-tycon-panic
    -get-linker-flags-correctly
    -fix-ppc-lwa-generation
    -smp-arm-fix.patch
    -R_X86_64_REX_GOTPCRELX
  * Remove old prof_scc.png link on ghc-doc (Closes: #855627)
  * Bump std-version to 4.0.0
  * Bump compat level to 10, dropping autoreconf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 21 Feb 2017 17:07:37 +0100

=== debian/control ===
Source: ghc
Section: haskell
Priority: optional
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>, Clint Adams <clint@debian.org>
Standards-Version: 4.1.1
Build-Depends:
  debhelper (>= 10),
  haskell-devscripts-minimal <!cross>,
  devscripts,
  grep-dctrl,
  pkg-config,
  ghc:native (>= 7.8),
  libgmp-dev,
  llvm-3.7 [arm64 armel armhf],
  libffi-dev,
  binutils [arm64 armel armhf],
  libncurses5-dev,
  python-sphinx <!cross>,
  dpkg-dev (>= 1.16.1.1)
Build-Depends-Indep:
  hscolour,
  fop
Build-Conflicts:
  ccache,
  ghc (= 8.0.0.20160111-3),
Homepage: http://haskell.org/ghc/
Vcs-Git: https://anonscm.debian.org/git/pkg-haskell/DHG_packages.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/

Package: ghc
Architecture: any
Depends:
  llvm-3.7 [arm64 armel armhf],
  gcc,
  libgmp-dev,
  libffi-dev,
  libbsd-dev,
  libc6-dev,
  libncurses5-dev,
  ${shlibs:Depends},
  ${misc:Depends}
Pre-Depends: dpkg (>= 1.16.1)
Provides:
  haskell-compiler,
  ghc-dynamic,
  ${ghci},
  ${provided-devs},
  ${haskell:Provides},
  haddock,
  ghc-haddock,
  ${haddock:Provides}
Replaces: ghc6 (<< 7), ghc-dynamic (<< 7.8), ghc-haddock (<< 7.10)
Conflicts: ghc6 (<< 7), ghc-dynamic (<< 7.8), libghc-cabal-dev (<< 1.24.2.1), ${conflicting-devs}
Breaks: cabal-install (<< 1.22), haskell-devscripts (<< 0.8.13), ghc-doc (<< 7.10), ghc-haddock (<< 7.10)
Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-3.7
Description: The Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.

Package: ghc-prof
Architecture: any
Provides: ${provided-profs}, ${haskell:Provides}
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Replaces: ghc6-prof (<< 7)
Conflicts: ghc6-prof (<< 7)
Description: Profiling libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package contains additional profiling libraries. They are only needed,
 if you want to take a closer look on where exactly your program burns CPU
 cycles.

Package: ghc-doc
Section: doc
Architecture: all
Suggests: haskell-doc
Provides: ${provided-docs}
Replaces: ghc6-doc (<< 7), libghc-terminfo-doc (<< 0.3.2.5-4), libghc-transformers-doc (<< 0.3.0.0-6), libghc-xhtml-doc (<< 3000.2.1-5)
Conflicts: ghc6-doc (<< 7), ghc (<= 7.0.3-1)
Breaks: libghc-terminfo-doc (<< 0.3.2.5-4), libghc-transformers-doc (<< 0.3.0.0-6), libghc-xhtml-doc (<< 3000.2.1-5)
Depends: ${haddock:Depends}, ${misc:Depends}, perl, libjs-mathjax
Pre-Depends: dpkg (>= 1.16.1)
Description: Documentation for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package includes HTML, DVI and PS versions of the SGML-based
 documentation around GHC.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.
#
# This version is for a multibinary package. It also allows you to build any
# of the binary packages independantly, via binary-<package> targets.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# # Set default flags with dpkg-buildflags
# # This might also close #712228
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
# ghc-cabal expects it to be available.
export HOME = /homedoesnotexistatbuildtime

# From /usr/share/doc/autotools-dev/examples/rules.gz:
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# We're cross-building if DEB_BUILD_GNU_TYPE != DEB_HOST_GNU_TYPE
ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  confflags += --target $(DEB_HOST_GNU_TYPE) --enable-unregisterised
  BUILD_CROSS=YES
else
  BUILD_CROSS=NO
endif

ProjectVersion=$(shell cat VERSION)

GHC=$(firstword $(shell bash -c "type -p ghc"))
EXTRA_CONFIGURE_FLAGS=--with-ghc="$(GHC)"

DEB_HOOGLE_TXT_DIR = /usr/lib/ghc-doc/hoogle/

ifneq (,$(filter powerpcspe x32, $(DEB_HOST_ARCH)))
  EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
endif

%:
	dh $@

override_dh_autoreconf:
	dh_autoreconf perl -- boot

override_dh_auto_configure:
	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
ifeq (NO,$(BUILD_CROSS))
	echo "HADDOCK_DOCS := YES" >> mk/build.mk
	echo "EXTRA_HADDOCK_OPTS += --mathjax=file:///usr/share/javascript/mathjax/MathJax.js" >> mk/build.mk
	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
else
	echo "SRC_HC_OPTS += -O0 -H64m" >> mk/build.mk
	echo "GhcStage1HcOpts = -O" >> mk/build.mk
	echo "GhcStage2HcOpts = -O0" >> mk/build.mk
	echo "GhcLibHcOpts = -O" >> mk/build.mk
	echo "SplitObjs = NO" >> mk/build.mk
	echo "HADDOCK_DOCS := NO" >> mk/build.mk
	echo "BUILD_SPHINX_HTML := NO" >> mk/build.mk
	echo "BUILD_SPHINX_PDF := NO" >> mk/build.mk
endif
ifneq (,$(filter arm64 armel armhf, $(DEB_HOST_ARCH)))
	echo "SRC_HC_OPTS     += -optl-B/usr/bin/ld.gold" >> mk/build.mk
endif
ifeq (armhf,$(DEB_HOST_ARCH))
	echo "SRC_HC_OPTS += -D__ARM_PCS_VFP" >> mk/build.mk
endif
ifeq (armel,$(DEB_HOST_ARCH))
	patch -p1 < debian/patches/armel-revert-ghci-fixes.patch
endif
ifneq (,$(filter mips mipsel, $(DEB_HOST_ARCH)))
	echo "SRC_HC_OPTS     += -optc--param -optcggc-min-expand=10" >> mk/build.mk
endif
ifeq (x32,$(DEB_HOST_ARCH))
	echo "INTEGER_LIBRARY = integer-simple" >> mk/build.mk
endif
ifneq (,$(filter nostrip, $(DEB_BUILD_OPTIONS)))
#	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
#	echo "GhcStage2HcOpts += -DDEBUG" >> mk/build.mk
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -Rghc-timing -DDEBUG" >> mk/build.mk
#	echo "GhcLibHcOpts  += -O -dcore-lint -keep-hc-files " >> mk/build.mk
	echo "SplitObjs     = NO" >> mk/build.mk
	echo "STRIP         = :" >> mk/build.mk
endif
ifneq (,$(filter noopt, $(DEB_BUILD_OPTIONS)))
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -O0" >> mk/build.mk
	# This breaks the build - to be investigated:
	# echo "GhcLibHcOpts  += -O0" >> mk/build.mk
	echo "GhcRtsCcOpts  += -O0" >> mk/build.mk
endif
	# We also want to build the threaded profiling-enabled debug runtime,
	# because it does no harm
	echo 'GhcRTSWays += $$(if $$(filter p, $$(GhcLibWays)),thr_debug_p,)' >> mk/build.mk

	# We can't do this with a configure flag in 6.8.1 as libdir is not
	# defined at the point at which we := it
	echo 'ghclibdir := $${libdir}/ghc' >> mk/build.mk
	echo 'bindir  := /usr/bin' >> mk/build.mk
	# docdir doesn't have a configure flag, and unfortunately
	# we also need to explicitly define all of its dependents as they
	# are set with :=
	echo 'docdir  := $$(datarootdir)/doc/ghc-doc' >> mk/build.mk
	echo 'htmldir := $$(docdir)'                   >> mk/build.mk
	echo 'dvidir  := $$(docdir)'                   >> mk/build.mk
	echo 'pdfdir  := $$(docdir)'                   >> mk/build.mk
	echo 'psdir   := $$(docdir)'                   >> mk/build.mk
	echo 'STRIP_CMD = $(DEB_HOST_GNU_TYPE)-strip'  >> mk/build.mk
	echo 'RANLIB_CMD = $(DEB_HOST_GNU_TYPE)-ranlib'>> mk/build.mk
	# We want verbose builds
	echo 'V=1'                                     >> mk/build.mk
	./configure $(confflags) --prefix=/usr \
		$(EXTRA_CONFIGURE_FLAGS) \
		--with-system-libffi \
		--with-llc=llc-3.7 \
		--with-opt=opt-3.7

override_dh_auto_build:
	dh_auto_build

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	# Do some very simple tests that the compiler actually works
	rm -rf debian/testghc
	mkdir debian/testghc
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo -O2
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	@printf "====BEGIN GHC INFO OUTPUT====\n"
	@inplace/bin/ghc-stage2 --info
	@printf "====END GHC INFO OUTPUT====\n"
endif

FILES = \( -type f -o -type l \)
PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)

override_dh_auto_install:
	dh_auto_install

	# Delete all the library LICENSE files
	rm -f debian/tmp/usr/share/doc/ghc-doc/html/libraries/*/LICENSE

	# Remove the haddock.t files, they really should not be in the released
	# package (upstream #10410)
	find debian/tmp -name \*.haddock.t -delete

	# Generate lintian overrides
	mkdir -p debian/tmp/usr/share/lintian/overrides
	echo "ghc binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.dyn_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc-prof binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.p_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc-prof

	# Sort out the package.conf files
	mkdir -p debian/tmp/var/lib/ghc
	# Old directories for symlink-workaround. Remove once all libraries use new path
	mv debian/tmp/usr/lib/ghc/package.conf.d \
	   debian/tmp/var/lib/ghc/
	rm debian/tmp/var/lib/ghc/package.conf.d/package.cache
	chmod +x debian/provided_substvars
	debian/provided_substvars
	sed -ri 's,^haddock-interfaces: /.*?/libraries/,haddock-interfaces: /usr/lib/ghc-doc/haddock/ghc/,' debian/tmp/var/lib/ghc/package.conf.d/*.conf

	# Sort out the binaries
	if inplace/bin/ghc-stage2 --info | grep '"Have interpreter","NO"'; then \
	    cd debian/tmp/usr/bin ;rm -f ghci* runghc* runhaskell*; \
	fi

	# Check if we have a ghci binary
	if test -e debian/tmp/usr/bin/ghci-$(ProjectVersion); then \
	    echo 'ghci=ghc-ghci' >> debian/ghc.substvars ; fi
ifeq (NO,$(BUILD_CROSS))
	# Add haddock substvars
	echo "haddock:Depends=haddock-interface-$$(debian/tmp/usr/lib/ghc/bin/haddock --interface-version)" >> debian/ghc-doc.substvars
	echo "haddock:Provides=haddock-interface-$$(debian/tmp/usr/lib/ghc/bin/haddock --interface-version)" >> debian/ghc.substvars
	find debian/tmp/usr/share/man $(FILES)           >> debian/ghc.install
	mkdir -p debian/tmp/usr/lib/ghc-doc
	cp debian/gen_contents_index debian/tmp/usr/lib/ghc-doc/
	chmod +x debian/tmp/usr/lib/ghc-doc/gen_contents_index
	mkdir debian/tmp/usr/lib/ghc-doc/haddock
	mkdir debian/tmp/usr/lib/ghc-doc/haddock/ghc/
	for f in `find debian/tmp/usr/share/doc/ghc-doc/html/libraries/ -maxdepth 1 -mindepth 1 -type d`; do \
	    mkdir debian/tmp/usr/lib/ghc-doc/haddock/ghc/`basename $$f` ; \

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/ \
https://downloads.haskell.org/~ghc/(\d[\d.rc-]*)/ghc-(\d[\d.]*)-src.tar.(?:bz2|xz|gz)

## ghc 8.2.2

=== Makefile ===
--- 
+++ 
@@ -76,13 +76,6 @@
 .PHONY: help
 help:
 	@cat MAKEHELP.md
-
-# Verify that stage 0 LLVM backend isn't affected by Bug #9439 if needed
-ifeq "$(GHC_LLVM_AFFECTED_BY_9439)" "1"
-ifneq "$(findstring -fllvm,$(SRC_HC_OPTS) $(GhcHcOpts) $(GhcStage1HcOpts))" ""
-$(error Stage 0 compiler is affected by Bug #9439. Refusing to bootstrap with -fllvm)
-endif
-endif
 
 # No need to update makefiles for these targets:
 # (the ones we're filtering out)

=== docs/users_guide/Makefile ===
dir = docs/users_guide
TOP = ../..

include $(TOP)/mk/sub-makefile.mk

# This makes 'make fast' work: assume that mkUserGuidePart exists
FAST_MAKE_OPTS += utils/mkUserGuidePart_dist_NOT_NEEDED=YES

=== driver/split/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = driver/split
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== libraries/Cabal/Cabal/Makefile ===

VERSION=2.0.1.0

#KIND=devel
KIND=rc
#KIND=cabal-latest

PREFIX=/usr/local
HC=ghc
GHCFLAGS=-Wall -threaded
SSH_USER=$(USER)

all: build

# build the library itself

SOURCES=Distribution/*.hs Distribution/Simple/*.hs \
	Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs \
	Distribution/Simple/Build/*.hs Distribution/Compat/*.hs \
	Distribution/Simple/Program/*.hs
CONFIG_STAMP=dist/setup-config
BUILD_STAMP=dist/build/libHSCabal-$(VERSION).a
HADDOCK_STAMP=dist/doc/html/Cabal/index.html
USERGUIDE_STAMP=dist/doc/users-guide/index.html
SDIST_STAMP=dist/Cabal-$(VERSION).tar.gz
DISTLOC=dist/release
DIST_STAMP=$(DISTLOC)/Cabal-$(VERSION).tar.gz

COMMA=,

setup: $(SOURCES) Setup.hs
	-mkdir -p dist/setup
	$(HC) $(GHCFLAGS) --make -i. -odir dist/setup -hidir dist/setup Setup.hs \
		-o setup

$(CONFIG_STAMP): setup Cabal.cabal
	./setup configure --with-compiler=$(HC) --prefix=$(PREFIX)

build: $(BUILD_STAMP)
$(BUILD_STAMP): $(CONFIG_STAMP) $(SOURCES)
	./setup build

install: $(BUILD_STAMP)
	./setup install

# documentation...

haddock: $(HADDOCK_STAMP)
$(HADDOCK_STAMP) : $(CONFIG_STAMP) $(BUILD_STAMP)
	./setup haddock

SPHINX_HTML_OUTDIR=dist/doc/users-guide

users-guide: $(USERGUIDE_STAMP)
$(USERGUIDE_STAMP) : doc/*.rst
	mkdir -p $(SPHINX_HTML_OUTDIR)
	sphinx-build doc $(SPHINX_HTML_OUTDIR)

docs: haddock users-guide

clean:
	rm -rf dist/
	rm -f setup

# testing...

moduleTest: tests/ModuleTest.hs tests/PackageDescriptionTests.hs
	mkdir -p dist/test
	$(HC) --make -Wall -DDEBUG -odir dist/test -hidir dist/test \
		-itests tests/ModuleTest.hs -o moduleTest

#tests: moduleTest clean
#	cd tests/A && $(MAKE) clean
#	cd tests/HUnit-1.0 && $(MAKE) clean
#	cd tests/A && $(MAKE)
#	cd tests/HUnit-1.0 && $(MAKE)

#check:
#	rm -f moduleTest
#	$(MAKE) moduleTest
#	./moduleTest

# distribution...

$(SDIST_STAMP) : $(BUILD_STAMP)
	./setup sdist

dist: $(DIST_STAMP)
$(DIST_STAMP) : $(HADDOCK_STAMP) $(USERGUIDE_STAMP) $(SDIST_STAMP)
	rm -rf $(DISTLOC)
	mkdir $(DISTLOC)
	tar -xzf $(SDIST_STAMP) -C $(DISTLOC)/
	mkdir -p $(DISTLOC)/Cabal-$(VERSION)/doc
	cp -r dist/doc/html $(DISTLOC)/Cabal-$(VERSION)/doc/API
	cp -r dist/doc/users-guide $(DISTLOC)/Cabal-$(VERSION)/doc/
	cp changelog $(DISTLOC)/Cabal-$(VERSION)/
	tar --format=ustar -C $(DISTLOC) -czf $(DISTLOC)/Cabal-$(VERSION).tar.gz Cabal-$(VERSION)
	mkdir $(DISTLOC)/doc
	mv $(DISTLOC)/Cabal-$(VERSION)/doc/users-guide $(DISTLOC)/doc
	mv $(DISTLOC)/Cabal-$(VERSION)/doc/API $(DISTLOC)/doc
	mv $(DISTLOC)/Cabal-$(VERSION)/changelog $(DISTLOC)/
	rm -r $(DISTLOC)/Cabal-$(VERSION)/
	@echo "Cabal tarball built: $(DIST_STAMP)"
	@echo "Release fileset prepared: $(DISTLOC)/"

# Out of date, use SFTP
#release: $(DIST_STAMP)
#	scp -r $(DISTLOC) $(SSH_USER)@haskell.org:/home/web/haskell.org/cabal/release/cabal-$(VERSION)
#	ssh $(SSH_USER)@haskell.org 'cd /home/web/haskell.org/cabal/release && rm -f $(KIND) && ln -s cabal-$(VERSION) $(KIND)'

# tags...

TAGSSRCDIRS = Distribution Language
tags TAGS: $(SOURCES)
	find $(TAGSSRCDIRS) -name \*.\*hs | xargs hasktags

=== debian/changelog ===
ghc (8.2.2-5) unstable; urgency=medium

  * Apply patch to disable -Bsymbolic on unregisterised
    architectures.  closes: #904055.
  * Add autopkgtest.

 -- Clint Adams <clint@debian.org>  Wed, 18 Jul 2018 18:56:46 -0400

ghc (8.2.2-4) unstable; urgency=medium

  [ Clint Adams ]
  * Bump to Standards-Version 4.1.4.
  * Set Rules-Requires-Root to no.

  [ Ilias Tsitsimpis ]
  * Use system's default ld (ld.bfd) on mips/mipsel, instead of ld.gold

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Mon, 25 Jun 2018 12:24:52 +0300

ghc (8.2.2-3) unstable; urgency=medium

  * Upload to unstable.

 -- Clint Adams <clint@debian.org>  Sun, 08 Apr 2018 16:24:00 -0400

ghc (8.2.2-2) experimental; urgency=medium

  * Merge 8.0.2-12 unreleased changes.

 -- Clint Adams <clint@debian.org>  Sat, 07 Apr 2018 08:08:41 -0400

ghc (8.2.2-1) experimental; urgency=medium

  * Merge 8.0.2-11 unreleased changes
  * New upstream release, patch refresh
  * Fixup regex fix in watch file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Nov 2017 12:08:38 +0100

ghc (8.2.1-2) experimental; urgency=medium

  [ Sean Whitton ]
  * Upload to experimental again, after merging in changes from unstable.
    - Refresh patches.
    - Drop osdecommitmemory-compat.patch from series file
      Merged upstream.

  [ Clint Adams ]
  * Drop avoid-CrossCompilerPrefix-stage2.patch.

 -- Clint Adams <clint@debian.org>  Sun, 17 Sep 2017 07:52:14 -0400

ghc (8.2.1-1) experimental; urgency=medium

  * New upstream release

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 15 Sep 2017 17:15:49 -0700

ghc (8.2.0~20170507-3) experimental; urgency=medium

  * 8.2.1-rc2.
    - Switches to LLVM 3.9.

 -- Clint Adams <clint@debian.org>  Wed, 12 Jul 2017 17:51:16 -0400

ghc (8.0.2-12) UNRELEASED; urgency=medium

  [ Ilias Tsitsimpis ]
  * Use salsa.debian.org URLs in Vcs-{Browser,Git} fields

  [ Sean Whitton ]
  * Add lower-optimization-for-unreg.patch (Closes: #890763).

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 09 Feb 2018 20:44:09 +0200

ghc (8.2.0~20170507-2) experimental; urgency=medium

  * 8.2.1-rc2.
    - Switches to LLVM 3.9.

 -- Clint Adams <clint@debian.org>  Wed, 12 Jul 2017 17:51:16 -0400

ghc (8.2.0~20170507-1) experimental; urgency=medium

  * 8.2.1-rc2.

 -- Clint Adams <clint@debian.org>  Wed, 12 Jul 2017 17:51:16 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders: Joachim Breitner <nomeata@debian.org>, Clint Adams <clint@debian.org>
-Standards-Version: 4.1.1
+Standards-Version: 4.1.4
+Rules-Requires-Root: no
 Build-Depends:
   debhelper (>= 10),
   haskell-devscripts-minimal <!cross>,
@@ -12,7 +13,7 @@
   pkg-config,
   ghc:native (>= 7.8),
   libgmp-dev,
-  llvm-3.7 [arm64 armel armhf],
+  llvm-3.9 [arm64 armel armhf],
   libffi-dev,
   binutils [arm64 armel armhf],
   libncurses5-dev,
@@ -25,13 +26,13 @@
   ccache,
   ghc (= 8.0.0.20160111-3),
 Homepage: http://haskell.org/ghc/
-Vcs-Git: https://anonscm.debian.org/git/pkg-haskell/DHG_packages.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/
+Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/ghc]
+Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/ghc
 
 Package: ghc
 Architecture: any
 Depends:
-  llvm-3.7 [arm64 armel armhf],
+  llvm-3.9 [arm64 armel armhf],
   gcc,
   libgmp-dev,
   libffi-dev,
@@ -53,7 +54,7 @@
 Replaces: ghc6 (<< 7), ghc-dynamic (<< 7.8), ghc-haddock (<< 7.10)
 Conflicts: ghc6 (<< 7), ghc-dynamic (<< 7.8), libghc-cabal-dev (<< 1.24.2.1), ${conflicting-devs}
 Breaks: cabal-install (<< 1.22), haskell-devscripts (<< 0.8.13), ghc-doc (<< 7.10), ghc-haddock (<< 7.10)
-Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-3.7
+Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-3.9
 Description: The Glasgow Haskell Compilation system
  The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
  Haskell.

=== debian/rules ===
--- 
+++ 
@@ -40,6 +40,15 @@
 
 ifneq (,$(filter powerpcspe x32, $(DEB_HOST_ARCH)))
   EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
+endif
+
+# Use system's default ld (ld.bfd) rather than ld.gold, which fails for
+# haskell-cryptohash-sha256 on mips/mipsel. For more information, see
+# https://bugs.debian.org/901947
+# NOTE: This should probably be removed, and revert back to using ld.gold,
+# once #901947 has been fixed.
+ifneq (,$(filter mips mipsel, $(DEB_HOST_ARCH)))
+  EXTRA_CONFIGURE_FLAGS += --disable-ld-override
 endif
 
 %:
@@ -118,8 +127,8 @@
 	./configure $(confflags) --prefix=/usr \
 		$(EXTRA_CONFIGURE_FLAGS) \
 		--with-system-libffi \
-		--with-llc=llc-3.7 \
-		--with-opt=opt-3.7
+		--with-llc=llc-3.9 \
+		--with-opt=opt-3.9
 
 override_dh_auto_build:
 	dh_auto_build
@@ -186,8 +195,3 @@
 	find debian/tmp/usr/share/man $(FILES)           >> debian/ghc.install
 	mkdir -p debian/tmp/usr/lib/ghc-doc
 	cp debian/gen_contents_index debian/tmp/usr/lib/ghc-doc/
-	chmod +x debian/tmp/usr/lib/ghc-doc/gen_contents_index
-	mkdir debian/tmp/usr/lib/ghc-doc/haddock
-	mkdir debian/tmp/usr/lib/ghc-doc/haddock/ghc/
-	for f in `find debian/tmp/usr/share/doc/ghc-doc/html/libraries/ -maxdepth 1 -mindepth 1 -type d`; do \
-	    mkdir debian/tmp/usr/lib/ghc-doc/haddock/ghc/`basename $$f` ; \

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/,dirversionmangle=s/-rc/~rc/ \
https://downloads.haskell.org/~ghc/(\d[\d.rc-]*)/ghc-(\d[\d.]*)-src.tar.(?:bz2|xz|gz)

## ghc 8.4.4%2Bdfsg1

=== utils/unlit/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/unlit
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== debian/changelog ===
ghc (8.4.4+dfsg1-3) unstable; urgency=medium

  * Use the ARM7TDMI core on armel (Closes: #915333)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Thu, 20 Jun 2019 00:08:21 +0300

ghc (8.4.4+dfsg1-2) unstable; urgency=medium

  [ Clint Adams ]
  * Patch Sphinx config to use locally-installed MathJax instead of a
    copy on the Internet.  closes: #919518.

  [ Gianfranco Costamagna ]
  * Fix sphinx 1.8 build with upstream patch (Closes: #923445)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 28 Feb 2019 15:18:49 +0100

ghc (8.4.4+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches to apply cleanly on new upstream
  * Apply patch to build on GNU/kFreeBSD (Closes: #913140)
  * Backport upstream patch to allow GHC to build on arm*

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 30 Nov 2018 12:11:18 +0200

ghc (8.4.3+dfsg1-4) unstable; urgency=medium

  * Add missing Breaks+Replaces+Provides (Closes: #910480).
    Break+Replace+Provide all bundled libraries, including libghc-parsec3-dev.

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 19 Oct 2018 13:09:22 +0300

ghc (8.4.3+dfsg1-3) unstable; urgency=medium

  * Conflict with mtl and stm.  closes: #910008.

 -- Clint Adams <clint@debian.org>  Thu, 18 Oct 2018 18:20:40 -0400

ghc (8.4.3+dfsg1-2) unstable; urgency=medium

  * Upload to unstable

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Wed, 26 Sep 2018 12:10:37 +0300

ghc (8.4.3+dfsg1-1) experimental; urgency=medium

  * Backport upstream commit 18cb44dfae3f.
    This fixes upstream bug #15213 (32 bit Haddock runs out of memory
    compiling 32 bit GHC).
  * Remove DFSG incompatible file (Closes: #870683).

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 21 Sep 2018 23:05:59 +0300

ghc (8.4.3-7) experimental; urgency=medium

  * Backport upstream commit ec9aacf3eb2 (add -latomic to ghc-prim)
  * Use system's default ld (ld.bfd) on sparc64, instead of ld.gold
    (Closes: #908998)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Tue, 18 Sep 2018 14:30:06 +0300

ghc (8.4.3-6) experimental; urgency=medium

  [ Gianfranco Costamagna ]
  * Try to fix armel build

  [ John Paul Adrian Glaubitz ]
  * ghc: disable ld override on powerpcspe too

  [ Ilias Tsitsimpis ]
  * Allow unregisterised ghc-8.2 to build newer GHC
  * Bump to Standards-Version 4.2.1

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 14 Sep 2018 14:32:12 +0300

ghc (8.4.3-5) experimental; urgency=medium

  * Switch to dh_auto_configure, making the correct triplet
    being passed to the build system, with also --target flag
    (this should hopefully make the configure more robust, and
    stop failing now that armhf runs on arm64 systems)
    - thanks waldi, jcristay for the help

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 20 Jul 2018 13:52:19 +0200

ghc (8.4.3-4) experimental; urgency=medium

  * merge with unstable 8.2.2-6

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 20 Jul 2018 00:24:43 +0200

ghc (8.4.3-3) experimental; urgency=medium

  * Switch configure.ac to search for llvm 6.0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 19 Jul 2018 12:16:02 +0200

ghc (8.4.3-2) experimental; urgency=medium

  [ Gianfranco Costamagna ]
  * Remove old and non-applied anymore powerpcspe-disable-FPU-code.patch.
    (Closes: #900817)
  * Switch to llvm 6.0 (Closes: #850915)

  [ Clint Adams ]
  * Merge in 8.2.2-5.

 -- Clint Adams <clint@debian.org>  Wed, 18 Jul 2018 19:12:59 -0400

ghc (8.4.3-1) experimental; urgency=medium

  * New upstream version.
  * Apply upstream patch to build on armhf.

 -- Clint Adams <clint@debian.org>  Wed, 30 May 2018 18:34:37 -0400

ghc (8.4.2-1) experimental; urgency=medium

  * New upstream release

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 23 Apr 2018 10:28:43 +0200

ghc (8.4.1-2) experimental; urgency=medium

  * Refresh armel patch, but do not apply it, to see
    if upstream changes are enough to make it build again

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Apr 2018 08:58:07 +0200

ghc (8.4.1-1) experimental; urgency=medium

  * New upstream release, patch refresh
  * Bump std-version to 4.1.4, no changes required
  * d/{rules,control}: switch to llvm 5.0 on arm*
  * Drop patches included in new upstream release:
    - reproducible-tmp-names
    - do-not-use-SHELL
    - build-unlit-and-hp2ps-twice.patch
    - fix-hssplicety.patch
    - lower-optimization-for-unreg.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 09 Apr 2018 15:54:00 +0200

ghc (8.2.2-6) unstable; urgency=medium

  * debian/patches/{risc-support,e175aaf6918bb2b497b83618dc4c270a0d231a1c}.patch
    - add upstream patches to support risc* platforms (Closes: #904096)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 19 Jul 2018 19:24:01 +0200
